moeoNSGA(3)

NAME
moeoNSGA - NSGA (Non-dominated Sorting Genetic Algorithm) as described in: N.

SYNOPSIS

#include <moeoNSGA.h>

Inherits moeoEA< MOEOT >< MOEOT >.

  Public Member Functions
moeoNSGA (unsigned int _maxGen, eoEvalFunc< MOEOT > &_eval, eoGenOp< MOEOT > &_op, double _nicheSize=0.5)
Simple ctor with a eoGenOp.
moeoNSGA (unsigned int _maxGen, eoEvalFunc< MOEOT > &_eval, eoTransform< MOEOT > &_op, double _nicheSize=0.5)
Simple ctor with a eoTransform.
moeoNSGA (unsigned int _maxGen, eoEvalFunc< MOEOT > &_eval, eoQuadOp< MOEOT > &_crossover, double _pCross, eoMonOp< MOEOT > &_mutation, double _pMut, double _nicheSize=0.5)
Ctor with a crossover, a mutation and their corresponding rates.
moeoNSGA (eoContinue< MOEOT > &_continuator, eoEvalFunc< MOEOT > &_eval, eoGenOp< MOEOT > &_op, double _nicheSize=0.5)
Ctor with a continuator (instead of _maxGen) and a eoGenOp.
moeoNSGA (eoContinue< MOEOT > &_continuator, eoEvalFunc< MOEOT > &_eval, eoTransform< MOEOT > &_op, double _nicheSize=0.5)
Ctor with a continuator (instead of _maxGen) and a eoTransform.
virtual void operator() (eoPop< MOEOT > &_pop)
Apply a few generation of evolution to the population _pop until the stopping criteria is verified.

  Protected Attributes
eoGenContinue< MOEOT > defaultGenContinuator
a continuator based on the number of generations (used as default)
eoContinue< MOEOT > & continuator
stopping criteria
eoPopLoopEval< MOEOT > popEval
evaluation function used to evaluate the whole population
moeoDetTournamentSelect< MOEOT > select
binary tournament selection
moeoFastNonDominatedSortingFitnessAssignment< MOEOT > fitnessAssignment
fitness assignment used in NSGA-II
moeoFrontByFrontSharingDiversityAssignment< MOEOT > diversityAssignment
diversity assignment used in NSGA-II
moeoElitistReplacement< MOEOT > replace
elitist replacement
eoSGAGenOp< MOEOT > defaultSGAGenOp
an object for genetic operators (used as default)
eoGeneralBreeder< MOEOT > genBreed
general breeder
eoBreed< MOEOT > & breed
breeder

Detailed Description

  template<class MOEOT> class moeoNSGA< MOEOT >
NSGA (Non-dominated Sorting Genetic Algorithm) as described in: N. Srinivas, K. Deb, 'Multiobjective Optimization Using Nondominated Sorting in Genetic Algorithms'. Evolutionary Computation, Vol. 2(3), No 2, pp. 221-248 (1994). This class builds the NSGA algorithm only by using the fine-grained components of the ParadisEO-MOEO framework.

Definition at line 37 of file moeoNSGA.h.

Constructor & Destructor Documentation

  template<class MOEOT> moeoNSGA< MOEOT >::moeoNSGA (unsigned int _maxGen, eoEvalFunc< MOEOT > & _eval, eoGenOp< MOEOT > & _op, double _nicheSize = 0.5) [inline]

Simple ctor with a eoGenOp.

Parameters:
    _maxGen number of generations before stopping
    _eval evaluation function
    _op variation operator
    _nicheSize niche size

Definition at line 48 of file moeoNSGA.h.

  template<class MOEOT> moeoNSGA< MOEOT >::moeoNSGA (unsigned int _maxGen, eoEvalFunc< MOEOT > & _eval, eoTransform< MOEOT > & _op, double _nicheSize = 0.5) [inline]

Simple ctor with a eoTransform.

Parameters:
    _maxGen number of generations before stopping
    _eval evaluation function
    _op variation operator
    _nicheSize niche size

Definition at line 61 of file moeoNSGA.h.

  template<class MOEOT> moeoNSGA< MOEOT >::moeoNSGA (unsigned int _maxGen, eoEvalFunc< MOEOT > & _eval, eoQuadOp< MOEOT > & _crossover, double _pCross, eoMonOp< MOEOT > & _mutation, double _pMut, double _nicheSize = 0.5) [inline]

Ctor with a crossover, a mutation and their corresponding rates.

Parameters:
    _maxGen number of generations before stopping
    _eval evaluation function
    _crossover crossover
    _pCross crossover probability
    _mutation mutation
    _pMut mutation probability
    _nicheSize niche size

Definition at line 77 of file moeoNSGA.h.

  template<class MOEOT> moeoNSGA< MOEOT >::moeoNSGA (eoContinue< MOEOT > & _continuator, eoEvalFunc< MOEOT > & _eval, eoGenOp< MOEOT > & _op, double _nicheSize = 0.5) [inline]

Ctor with a continuator (instead of _maxGen) and a eoGenOp.

Parameters:
    _continuator stopping criteria
    _eval evaluation function
    _op variation operator
    _nicheSize niche size

Definition at line 91 of file moeoNSGA.h.

  template<class MOEOT> moeoNSGA< MOEOT >::moeoNSGA (eoContinue< MOEOT > & _continuator, eoEvalFunc< MOEOT > & _eval, eoTransform< MOEOT > & _op, double _nicheSize = 0.5) [inline]

Ctor with a continuator (instead of _maxGen) and a eoTransform.

Parameters:
    _continuator stopping criteria
    _eval evaluation function
    _op variation operator
    _nicheSize niche size

Definition at line 104 of file moeoNSGA.h.

Member Function Documentation

  template<class MOEOT> virtual void moeoNSGA< MOEOT >::operator() (eoPop< MOEOT > & _pop) [inline, virtual]

Apply a few generation of evolution to the population _pop until the stopping criteria is verified.

Parameters:
    _pop the population

Definition at line 114 of file moeoNSGA.h.

References moeoNSGA< MOEOT >::breed, moeoNSGA< MOEOT >::continuator, moeoNSGA< MOEOT >::diversityAssignment, moeoNSGA< MOEOT >::fitnessAssignment, moeoNSGA< MOEOT >::popEval, and moeoNSGA< MOEOT >::replace.

Author

Generated automatically by Doxygen for ParadisEO-MOEO from the source code.